﻿using System;
using System.Collections.Generic;
using Telerik.Web.Analytics;
using Telerik.Web.UI;

namespace RadgridDynamicIssue
{
    public partial class RadgridIssuePage : System.Web.UI.Page
    {
        public RadGrid rgDynamic;
        protected void Page_Init(object sender, System.EventArgs e)
        {
            rgDynamic = new RadGrid();
            rgDynamic.ID = "rgDynamic";
            rgDynamic.NeedDataSource += rgDynamic_OnNeedDataSource;
            rgDynamic.ExportSettings.Excel.Format = GridExcelExportFormat.Biff;
            rgDynamic.ExportSettings.IgnorePaging = true;
            rgDynamic.AutoGenerateColumns = false;
            rgDynamic.MasterTableView.EnableColumnsViewState = false;

            var colGroup1 = new GridColumnGroup();
            colGroup1.Name = "cg1";
            colGroup1.HeaderText = "Col Group 1";
            rgDynamic.MasterTableView.ColumnGroups.Add(colGroup1);

            var colPre1 = new GridBoundColumn();
            colPre1.UniqueName = "col1";
            colPre1.HeaderText = "Col 1";
            rgDynamic.MasterTableView.Columns.Add(colPre1);

            if (string.IsNullOrEmpty(Request.Form.Get(rbExportGrid1.UniqueID)))
            {
                //Invisible Column
                var colPre2 = new GridBoundColumn();
                colPre2.UniqueName = "col2";
                colPre2.HeaderText = "Col 2";
                colPre2.Visible = false;
                rgDynamic.MasterTableView.Columns.Add(colPre2);
            }

            var col1 = new GridBoundColumn();
            col1.UniqueName = "col3";
            col1.HeaderText = "Col 3";
            col1.ColumnGroupName = "cg1";
            rgDynamic.MasterTableView.Columns.Add(col1);

            var col2 = new GridBoundColumn();
            col2.UniqueName = "col4";
            col2.HeaderText = "Col 4";
            col2.ColumnGroupName = "cg1";
            rgDynamic.MasterTableView.Columns.Add(col2);

            PlaceHolder1.Controls.Add(rgDynamic);
        }
        protected void exportGrid_Click(object sender, EventArgs e)
        {
            rgDynamic.MasterTableView.ExportToExcel();
        }
        protected void rgDynamic_OnNeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            rgDynamic.DataSource = String.Empty;
        }
    }
}